palette = require './palette.coffee'

map =
  '': <symbol viewBox="0 0 16 16"/>

  # Environment
  brick: <symbol viewBox="0 0 16 16"><image xlink:href="brick_#{palette}.png"/></symbol>
  brick_lit: <symbol viewBox="0 0 16 16"><image xlink:href="brick_lit_#{palette}.png"/></symbol>
  question: <symbol viewBox="0 0 16 16"><image xlink:href="question_#{palette}.png"/></symbol>
  question_used: <symbol viewBox="0 0 16 16"><image xlink:href="question_used_#{palette}.png"/></symbol>
  raised: <symbol viewBox="0 0 16 16"><image xlink:href="raised_#{palette}.png"/></symbol>
  rock: <symbol viewBox="0 0 16 16"><image xlink:href="rock_#{palette}.png"/></symbol>

  # Players
  mario_small_left: <symbol viewBox="0 0 16 16" z-index="2"><image y="1" xlink:href="mario_small_left.png"/></symbol>
  mario_small_right: <symbol viewBox="0 0 16 16" z-index="2"><image y="1" xlink:href="mario_small_right.png"/></symbol>
  mario_large_left: <symbol viewBox="0 0 16 16" z-index="2"><image y="-15" xlink:href="mario_large_left.png"/></symbol>
  mario_large_right: <symbol viewBox="0 0 16 16" z-index="2"><image y="-15" xlink:href="mario_large_right.png"/></symbol>
  luigi_small_left: <symbol viewBox="0 0 16 16" z-index="2"><image y="1" xlink:href="luigi_small_left.png"/></symbol>
  luigi_small_right: <symbol viewBox="0 0 16 16" z-index="2"><image y="1" xlink:href="luigi_small_right.png"/></symbol>
  luigi_large_left: <symbol viewBox="0 0 16 16" z-index="2"><image y="-15" xlink:href="luigi_large_left.png"/></symbol>
  luigi_large_right: <symbol viewBox="0 0 16 16" z-index="2"><image y="-15" xlink:href="luigi_large_right.png"/></symbol>

  # Enemies
  goomba: <symbol viewBox="0 0 16 16" z-index="1"><image y="1" xlink:href={"goomba_#{palette}".png}/></symbol>
  spiny_left: <symbol viewBox="0 0 16 16" z-index="1"><image y="1" xlink:href="spiny_left.png"/></symbol>
  spiny_right: <symbol viewBox="0 0 16 16" z-index="1"><image y="1" xlink:href="spiny_right.png"/></symbol>

build = (key) ->
  key = key.trim()
  if ',' in key
    <symbol viewBox="0 0 16 16">
      {for subkey in key.split ','
        tile = build subkey
        if tile?
          tile.props?.children
        else
          console.warn "Unrecognized subtitle '#{subkey}'"
      }
    </symbol>
  else if match = /^(.*?)([+-]\d+)([+-]\d+)?$/.exec key
    tile = map[match[1]]
    offsetX = parseInt match[2]
    offsetY = parseInt (match[3] ? '0')
    return unless tile?
    tile.props.viewBox = tile.props.viewBox.replace /^(\d+) (\d+)/,
      (m, x, y) -> "#{-offsetX + parseInt x} #{-offsetY + parseInt y}"
    tile
  else
    map[key]
